/***************************************************************************
                          dlgborder.h  -  description
                             -------------------
    begin                : Thu Apr 26 2001
    copyright            : (C) 2001 by benny
    email                : bm@cage.rug.ac.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DLGBORDER_H
#define DLGBORDER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "dlgborderdesign.h"

//forward declaration
class K2dDomain;
class K2dBorderBase;

/**Dialog for input of the borders of our domain
      Inherits the designed version, so it can extend and
       implement the design
  *@author benny
  */

class dlgBorder : public dlgBorderDesign {
  Q_OBJECT
  public:
    /** give, on construction, the domain on wich the dialog must modify
      */
	dlgBorder(K2dDomain* , QWidget *parent = 0,const char* name=0);
	~dlgBorder();
    /** Validation of given values in the dialog
      */
    QString validateInput();
    /** Set the view of the dialog equal to border index of the domain
      */
    void loadBorder(uint index);

  /// Public slots
  public slots:
    /** slot saves the current border
      */
    bool slotBorderSave();
    void slotSaveExit();
    /** go to previous or next border
      */
    void slotPreviousBorder();
    void slotNextBorder();
    /** make it possible to add a border at the end
      */
    void slotAddEnd();
    /** delete the border that's been shown right now
      */
    void slotDelete();

  private:
    K2dDomain *dlgDomain;
    /** We need to seperate the code to save borderbase specific data
         A specific border (line, curve) calls this function to save this data in a general fashion*/
    void borderBaseSave(K2dBorderBase *) ;
};

#endif
