/***************************************************************************
                          gfmfile.cpp  -  description
                             -------------------
    begin                : Mon Apr 23 2001
    copyright            : (C) 2001 by benny
    email                : bm@cage.rug.ac.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "gfmfile.h"
#include <qstringlist.h>
#include <qdir.h>

#include "kconfigbackend.h"

gfmFile::gfmFile():KSimpleConfig(QDir::currentDirPath()+"/Untitled",false)
{
  bUntitled = true;
}
gfmFile::gfmFile(const QString &pFileName) :KSimpleConfig(pFileName, false)
{
  // the difference between a gfmfile and a KSimpleConfig file is that
  // these may only be saved if the specific command is given, therefore readonly is set to true
  // pFileName should be an entire path together with a name, or together with Untitled
  if (!pFileName.isEmpty())
     {bUntitled = true;
   }else {bUntitled = false;
  }
}
gfmFile::~gfmFile(){
}
void gfmFile::changeFileName(const QString &pFileName)
{
//We allow to give a file another name, and we also allow the path be undefined at the moment of
//creation, making it necessary to be able to give it another name, so it is no longer untitled
 if (pFileName.isEmpty()  || pFileName[0] != '/') {
    return;   //we do not allow that nothing is given, or the path is not given also
  } else {
     backEnd->changeFileName(pFileName, "config", false);
     bUntitled =false;
  }
}
/** a gfm model file has to be explicetely saved so that it would be stored to disk */
void gfmFile::save(){
 if (bUntitled) {
     return;
   }else {
     this->setReadOnly(false) ;
     this->sync();
     this->setReadOnly(true);         //if readonly is true, no saving occurs on deletion of our gfmFile
 }
}
/** //creating a new model file */
void gfmFile::newFile(){
  this->cleangfm();
  this->initgfm();
  this->changeFileName(QDir::currentDirPath()+"/Untitled");
  bUntitled = true;
}
/** //Opening an excisting model file */
void gfmFile::openFile(const KURL &url){
  this->cleangfm();
  this->changeFileName(url.path());
  this->reparseConfiguration () ;
  bUntitled = false;
}
/** //functie die de huidige model file waarmee je werkt volledig leeg maakt */
void gfmFile::cleangfm(){
   QStringList list = this->groupList();
   //delete all entries
    for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it ) {
            this->deleteGroup( (*it), true);
    }
}
/** //functie die de huidige model file opvult met de standaard groepen en waardes */
void gfmFile::initgfm(){
   this->setGroup("General Options");
   this->writeEntry("dparam", 0.0 );
}
