/***************************************************************************
                          gfmfile.h  -  description
                             -------------------
    begin                : Mon Apr 23 2001
    copyright            : (C) 2001 by benny
    email                : bm@cage.rug.ac.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GFMFILE_H
#define GFMFILE_H

#include <ksimpleconfig.h>
#include <kurl.h>

/**GfmFile is the class with the model data. 
It is organized like a config file, therefore the inheritance
A lot of the methods should be made unavailable for good use, but this is
suspended to a later version where this class should be on its own

  *@author benny
  */

class gfmFile : public KSimpleConfig
{
public:
	gfmFile();
	gfmFile( const QString &pFileName);
	virtual ~gfmFile();
    void   changeFileName(const QString &pFileName);
    /** a gfm model file has to be explicetely saved so that it would be stored to disk
      */
    void save();
    /** creating a new model file
      */
   void newFile();
   void openFile(const KURL &url);
   /** return if a modelfile is still untitled
     */
   bool untitled(){return bUntitled ; };

private:
    /** When a new document is created, it is untitled. Only when titled can the model be saved
      */
    bool bUntitled;
  /** function that empties the present modelfile completely
    */
  void cleangfm();
  /** function that fills the present model file with the standard groups and values
    */
  void initgfm();
};

#endif
