/***************************************************************************
                          k2dgrflowview.h  -  description
                             -------------------
    begin                : Mon Apr 23 11:45:13 CEST 2001
    copyright            : (C) 2001 by benny
    email                : bm@cage.rug.ac.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef K2DGRFLOWVIEW_H
#define K2DGRFLOWVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qmultilineedit.h>

//own includes
#include "grflowviewdesign.h"

class K2dGrFlowDoc;
class K2dDomain;
class PlotField;

/** The K2dGrFlowView class provides the view widget for the K2dGrFlowApp instance.	
 * Inherits from an automatically with QT designer constructed layout
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As K2dGrFlowView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the K2dGrFlowApp class to manipulate and display
 * the document structure provided by the K2dGrFlowDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class K2dGrFlowView : public GrFlowViewDesign
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    K2dGrFlowView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~K2dGrFlowView();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a K2dGrFlowApp instance as a parent
     * widget to get to the window document pointer by calling the K2dGrFlowApp::getDocument() method.
     *
     * @see K2dGrFlowApp#getDocument
     */
    K2dGrFlowDoc *getDocument() const;
    /** returns a pointer to the domain connected to the view instance. Mind that this method requires a K2dGrFlowApp instance as a parent
     * widget to get to the window domain pointer by calling the K2dGrFlowApp::getDocument() method.
     *
     * @see K2dGrFlowApp#getDomain
     */
    K2dDomain *getDomain() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);
    /** Validate the input of the d parameter. Return true when ok, false when not ok.
       It is left to the user to change the d parameter until ok */
    bool validate_dParam();
  /** wil restate the View. Call the function every time you want to reload the view from the current document */
   void loadMyView();

   /**the drawing area is a specific widget on our view, with specific drawing implementation
     */
   PlotField* pfResult;
   QHBoxLayout *layoutZoom ;
   QPushButton *cmdZoomOut ;
   QPushButton *cmdZoomIn ;
   QPushButton *cmdPrint ;
	
};

#endif // K2DGRFLOWVIEW_H
