/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mon Apr 23 11:45:13 CEST 2001
    copyright            : (C) 2001 by benny
    email                : bm@cage.rug.ac.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qdir.h>

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "k2dgrflow.h"

static const char *description =
	I18N_NOOP("K2dGrFlow is a tool to model 2 dimensional groundwaterflow.\n"
                            "The specific case of vertical flow is generated in saturated area's.\n"
                             "The Galarkin finite element method is the algorithm used.\n \n"
                              "The Easymesh programm is used to generate a mesh. ");	
	
static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{

	KAboutData aboutData( "k2dgrflow", I18N_NOOP("K2dGrFlow"),
		VERSION, description, KAboutData::License_GPL,
		"(c) 2001, benny", 0, 0, "bm@cage.rug.ac.be");
	aboutData.addAuthor("benny",0, "bm@cage.rug.ac.be");
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KApplication app;
 
  if (app.isRestored())
  {
    RESTORE(K2dGrFlowApp);
  }
  else 
  {
    K2dGrFlowApp *k2dgrflow = new K2dGrFlowApp();

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
		
		if (args->count())
		{
        k2dgrflow->openDocumentFile(args->arg(0));
		}
		else
		{
		  k2dgrflow->openDocumentFile();
		}
		args->clear();
  }

  return app.exec();
}  
